<template>
  <div v-if="!options.hideField">
    <!-- <pre>{{ options }}</pre> -->
    <div v-if="(!config.read_only || haveValue) && !config.disabled">
    <!-- {{ nodeData }} -->
      <template v-if="options && options.beforeField">
        <div v-for="(comp, index) in options.beforeField" :key="Math.random() + index">
          <component :is="comp" :node="node" :path="path"></component>
        </div>
      </template>

      <label :for="(path || []).join('.')">{{ label || config.label }} {{ path }}</label>
        <!-- {{ config.read_only ? 'READ ONLY' : '' }} {{ config.read_only && (!nodeData[key] || nodeData[key].length === 0) ? 'HIDDEN' : '' }} -->
      <component :is="componentSelection" :node="node" :path="path" :defaults="defaultValues"></component>

      <template v-if="options && options.afterField">
        <div v-for="(comp, index) in options.afterField" :key="Math.random() + index">
          <component :is="comp" :node="node" :path="path"></component>
        </div>
      </template>
    </div>
  </div>
</template>

<script>
import _ from 'lodash'

import { EDITABLE_FIELD_CONFIG, EDITABLE_WIDGETS_MAPPING } from '@/components/Editable/config'

import { mapGetters } from 'vuex'
// import DefaultField from '@/components/Editable/Fields/Widgets/DefaultFieldWidgetField'

export default {
  components: {
    // TextField,
    // LinkField
    // ItemsParagraphForm: () => import('./ItemsParagraphForm.vue'),
    // ItemsForm: () => import('./ItemsForm.vue'),
    // ItemForm: () => import('./ItemForm.vue')
  },

  props: {
    label: {
      type: String,
      required: false
    },
    node: {
      type: Object,
      required: true
    },
    path: {
      type: Array,
      required: true
    }
    // config: {
    //   type: Object,
    //   required: true
    // }
    // options: {
    //   type: Object,
    //   required: false,
    //   default: () => {}
    // }
    // index: {
    //   type: Number,
    //   required: false
    // }
  },

  data () {
    return {
      // defaultMapping: {
      //   'link_default': Link,
      //   'string_textfield': TextField,
      //   'field_text_formatted': TextField,
      //   'text_with_summary': TextArea,
      //   'string_textarea': TextField,
      //   'text_textarea': TextArea,
      //   'image_image': Image
      // }
      // excludeList: ['_type', 'nid']
    }
  },
  // watch: {
  //   nodeData: {
  //     handler (val) {
  //       console.log('node')
  //     },
  //     deep: true
  //   }
  // },

  computed: {
    ...mapGetters({
      getFieldConfig: 'Y3TI/getFieldConfig',
      getEditedField: 'Y3TI/getEditedField'
    }),

    config () {
      return this.getFieldConfig({ node: this.node, path: this.path })
    },

    parentConfig () {
      return this.getFieldConfig({ node: this.node, path: (this.path || []).slice(0, -1) })
    },

    optionsProps () {
      return {
        parentConfig: this.parentConfig,
        config: this.config,
        node: this.node,
        path: this.path,
        parentData: this.getEditedField({ node: this.node, path: (this.path || []).slice(0, -1) }),
        data: this.getEditedField({ node: this.node, path: this.path })
      }
    },

    options () {
      return this.getFieldOptions(this.optionsProps)
    },

    index () {
      return _.last(this.path)
    },

    defaultValues () {
      if (this.config.cardinality === -1) {
        return _.get(this.config, ['default', 0])
      } else if (this.config.cardinality === 1) {
        return this.config.default
      } else {
        if (_.isNumber(this.index) && this.index > -1) {
          return _.get(this.config, ['default', this.index])
        }
      }
      return this.config.default
    },

    componentSelection () {
      return this.getWidgetsMapping(this.optionsProps)
      // for (let display of this.config.display || []) {
      //   if (WIDGETS_MAPPING[display]) {
      //     return WIDGETS_MAPPING[display]
      //   }
      // }
      // return DefaultField
      // return _.get(this.mapping, this.config.display, DefaultField)
    },

    nodeData () {
      return _.isEmpty(this.path) ? this.node : _.get(this.node, this.path, {})
    },

    haveValue () {
      return !_.isEmpty(this.nodeData) || _.isBoolean(this.nodeData) || _.isNumber(this.nodeData)
    }
    // fieldsConfig () {
    //   return this.config.fields || {}
    // }
    // nodesList () {
    //   return this.getEditableNodes(this.$route.path)
    // }
    // editablePath () {
    //   return [ this.node._type, 'nid-' + this.node.nid, ...this.path ]
    // },

    // textfieldData () {
    //   return this.getEditableData(this.editablePath) || _.get(this.node, this.path)
    // }
  },

  methods: {
    getFieldOptions: EDITABLE_FIELD_CONFIG,
    getWidgetsMapping: EDITABLE_WIDGETS_MAPPING
    // ...mapActions({
    //   storeEditableFieldData: 'Y3TI/storeEditableFieldData'
    // }),

    // haveValue (data) {
    //   return !_.isEmpty(data) || _.isBoolean(data) || _.isNumber(data)
    // }

    // update (e) {
    //   this.storeEditableFieldData({ data: { path: this.editablePath, input: e.target.innerHTML } })
    // }
  },

  created () {
    // console.log('laaa')
  }
}
</script>

<style lang="scss" scoped>
</style>
